install.sh 7.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258
  1. #!/bin/sh
  2. # This script installs Ollama on Linux.
  3. # It detects the current operating system architecture and installs the appropriate version of Ollama.
  4. set -eu
  5. status() { echo ">>> $*" >&2; }
  6. error() { echo "ERROR $*"; exit 1; }
  7. warning() { echo "WARNING: $*"; }
  8. TEMP_DIR=$(mktemp -d)
  9. cleanup() { rm -rf $TEMP_DIR; }
  10. trap cleanup EXIT
  11. available() { command -v $1 >/dev/null; }
  12. require() {
  13. local MISSING=''
  14. for TOOL in $*; do
  15. if ! available $TOOL; then
  16. MISSING="$MISSING $TOOL"
  17. fi
  18. done
  19. echo $MISSING
  20. }
  21. [ "$(uname -s)" = "Linux" ] || error 'This script is intended to run on Linux only.'
  22. ARCH=$(uname -m)
  23. case "$ARCH" in
  24. x86_64) ARCH="amd64" ;;
  25. aarch64|arm64) ARCH="arm64" ;;
  26. *) error "Unsupported architecture: $ARCH" ;;
  27. esac
  28. SUDO=
  29. if [ "$(id -u)" -ne 0 ]; then
  30. # Running as root, no need for sudo
  31. if ! available sudo; then
  32. error "This script requires superuser permissions. Please re-run as root."
  33. fi
  34. SUDO="sudo"
  35. fi
  36. NEEDS=$(require curl awk grep sed tee xargs)
  37. if [ -n "$NEEDS" ]; then
  38. status "ERROR: The following tools are required but missing:"
  39. for NEED in $NEEDS; do
  40. echo " - $NEED"
  41. done
  42. exit 1
  43. fi
  44. status "Downloading ollama..."
  45. curl --fail --show-error --location --progress-bar -o $TEMP_DIR/ollama "https://ollama.ai/download/ollama-linux-$ARCH"
  46. for BINDIR in /usr/local/bin /usr/bin /bin; do
  47. echo $PATH | grep -q $BINDIR && break || continue
  48. done
  49. status "Installing ollama to $BINDIR..."
  50. $SUDO install -o0 -g0 -m755 -d $BINDIR
  51. $SUDO install -o0 -g0 -m755 $TEMP_DIR/ollama $BINDIR/ollama
  52. install_success() {
  53. status 'The Ollama API is now available at 0.0.0.0:11434.'
  54. status 'Install complete. Run "ollama" from the command line.'
  55. }
  56. trap install_success EXIT
  57. # Everything from this point onwards is optional.
  58. configure_systemd() {
  59. if ! id ollama >/dev/null 2>&1; then
  60. status "Creating ollama user..."
  61. $SUDO useradd -r -s /bin/false -m -d /usr/share/ollama ollama
  62. fi
  63. if getent group render >/dev/null 2>&1; then
  64. status "Adding ollama user to render group..."
  65. $SUDO usermod -a -G render ollama
  66. fi
  67. status "Adding current user to ollama group..."
  68. $SUDO usermod -a -G ollama $(whoami)
  69. status "Creating ollama systemd service..."
  70. cat <<EOF | $SUDO tee /etc/systemd/system/ollama.service >/dev/null
  71. [Unit]
  72. Description=Ollama Service
  73. After=network-online.target
  74. [Service]
  75. ExecStart=$BINDIR/ollama serve
  76. User=ollama
  77. Group=ollama
  78. Restart=always
  79. RestartSec=3
  80. Environment="PATH=$PATH"
  81. [Install]
  82. WantedBy=default.target
  83. EOF
  84. SYSTEMCTL_RUNNING="$(systemctl is-system-running || true)"
  85. case $SYSTEMCTL_RUNNING in
  86. running|degraded)
  87. status "Enabling and starting ollama service..."
  88. $SUDO systemctl daemon-reload
  89. $SUDO systemctl enable ollama
  90. start_service() { $SUDO systemctl restart ollama; }
  91. trap start_service EXIT
  92. ;;
  93. esac
  94. }
  95. if available systemctl; then
  96. configure_systemd
  97. fi
  98. if ! available lspci && ! available lshw; then
  99. warning "Unable to detect NVIDIA GPU. Install lspci or lshw to automatically detect and install NVIDIA CUDA drivers."
  100. exit 0
  101. fi
  102. check_gpu() {
  103. case $1 in
  104. lspci) available lspci && lspci -d '10de:' | grep -q 'NVIDIA' || return 1 ;;
  105. lshw) available lshw && $SUDO lshw -c display -numeric | grep -q 'vendor: .* \[10DE\]' || return 1 ;;
  106. nvidia-smi) available nvidia-smi || return 1 ;;
  107. esac
  108. }
  109. if check_gpu nvidia-smi; then
  110. status "NVIDIA GPU installed."
  111. exit 0
  112. fi
  113. if ! check_gpu lspci && ! check_gpu lshw; then
  114. install_success
  115. warning "No NVIDIA GPU detected. Ollama will run in CPU-only mode."
  116. exit 0
  117. fi
  118. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-7-centos-7
  119. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-8-rocky-8
  120. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-9-rocky-9
  121. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#fedora
  122. install_cuda_driver_yum() {
  123. status 'Installing NVIDIA repository...'
  124. case $PACKAGE_MANAGER in
  125. yum)
  126. $SUDO $PACKAGE_MANAGER -y install yum-utils
  127. $SUDO $PACKAGE_MANAGER-config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  128. ;;
  129. dnf)
  130. $SUDO $PACKAGE_MANAGER config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  131. ;;
  132. esac
  133. case $1 in
  134. rhel)
  135. status 'Installing EPEL repository...'
  136. # EPEL is required for third-party dependencies such as dkms and libvdpau
  137. $SUDO $PACKAGE_MANAGER -y install https://dl.fedoraproject.org/pub/epel/epel-release-latest-$2.noarch.rpm || true
  138. ;;
  139. esac
  140. status 'Installing CUDA driver...'
  141. if [ "$1" = 'centos' ] || [ "$1$2" = 'rhel7' ]; then
  142. $SUDO $PACKAGE_MANAGER -y install nvidia-driver-latest-dkms
  143. fi
  144. $SUDO $PACKAGE_MANAGER -y install cuda-drivers
  145. }
  146. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#ubuntu
  147. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#debian
  148. install_cuda_driver_apt() {
  149. status 'Installing NVIDIA repository...'
  150. curl -fsSL -o $TEMP_DIR/cuda-keyring.deb https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-keyring_1.1-1_all.deb
  151. case $1 in
  152. debian)
  153. status 'Enabling contrib sources...'
  154. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list | $SUDO tee /etc/apt/sources.list.d/contrib.list > /dev/null
  155. if [ -f "/etc/apt/sources.list.d/debian.sources" ]; then
  156. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list.d/debian.sources | $SUDO tee /etc/apt/sources.list.d/contrib.sources > /dev/null
  157. fi
  158. ;;
  159. esac
  160. status 'Installing CUDA driver...'
  161. $SUDO dpkg -i $TEMP_DIR/cuda-keyring.deb
  162. $SUDO apt-get update
  163. [ -n "$SUDO" ] && SUDO_E="$SUDO -E" || SUDO_E=
  164. DEBIAN_FRONTEND=noninteractive $SUDO_E apt-get -y install cuda-drivers -q
  165. }
  166. if [ ! -f "/etc/os-release" ]; then
  167. error "Unknown distribution. Skipping CUDA installation."
  168. fi
  169. . /etc/os-release
  170. OS_NAME=$ID
  171. OS_VERSION=$VERSION_ID
  172. PACKAGE_MANAGER=
  173. for PACKAGE_MANAGER in dnf yum apt-get; do
  174. if available $PACKAGE_MANAGER; then
  175. break
  176. fi
  177. done
  178. if [ -z "$PACKAGE_MANAGER" ]; then
  179. error "Unknown package manager. Skipping CUDA installation."
  180. fi
  181. if ! check_gpu nvidia-smi || [ -z "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  182. case $OS_NAME in
  183. centos|rhel) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -d '.' -f 1) ;;
  184. rocky) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -c1) ;;
  185. fedora) install_cuda_driver_yum $OS_NAME $OS_VERSION ;;
  186. amzn) install_cuda_driver_yum 'fedora' '35' ;;
  187. debian) install_cuda_driver_apt $OS_NAME $OS_VERSION ;;
  188. ubuntu) install_cuda_driver_apt $OS_NAME $(echo $OS_VERSION | sed 's/\.//') ;;
  189. *) exit ;;
  190. esac
  191. fi
  192. if ! lsmod | grep -q nvidia; then
  193. KERNEL_RELEASE="$(uname -r)"
  194. case $OS_NAME in
  195. rocky) $SUDO $PACKAGE_MANAGER -y install kernel-devel kernel-headers ;;
  196. centos|rhel|amzn) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE kernel-headers-$KERNEL_RELEASE ;;
  197. fedora) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE ;;
  198. debian|ubuntu) $SUDO apt-get -y install linux-headers-$KERNEL_RELEASE ;;
  199. *) exit ;;
  200. esac
  201. NVIDIA_CUDA_VERSION=$($SUDO dkms status | awk -F: '/added/ { print $1 }')
  202. if [ -n "$NVIDIA_CUDA_VERSION" ]; then
  203. $SUDO dkms install $NVIDIA_CUDA_VERSION
  204. fi
  205. if lsmod | grep -q nouveau; then
  206. status 'Reboot to complete NVIDIA CUDA driver install.'
  207. exit 0
  208. fi
  209. $SUDO modprobe nvidia
  210. fi
  211. status "NVIDIA CUDA drivers installed."